# These functions are used in the diagnostic report.

# Other functions ----
# Function to upper only the first letter
firstup <- function(x) {
  substr(x, 1, 1) <- toupper(substr(x, 1, 1))
  x
}

# Return table of parameters information 
topline_parameters <- function(params) { 
  
  tribble(
    ~"Geography", ~"Reporting group", ~"Date the report was run", ~"Year",
    
    # Print Geography 
    if (params$geography == "County") {
      
      params$geography
      
    } else if (params$geography == "Triad") {
      
      paste0(params$sub_geography, " ", params$geography) 
      
    } else if (params$geography == "Township") {
      
      paste0(params$sub_geography, " ", params$geography)
      
    }, 
    # Print reporting group
    params$reporting_class, 
    #Print current date
    Sys.Date(), 
    # Print year
    params$year
  ) %>% 
    gt() %>%
    tab_header(
      title = "Report parameters")
  
}

# IAAO stats ----
# Print a table showing IAAO stats. 
table_iaao <- function(iaao_stats, params) {
  tribble(
    ~"Category", ~"Statistic", ~"Target Range",
    ~"Initial values", ~"Initial standard met", 
    ~"Mailed values", ~"Mailed standard met",
    ~"Assessor values", ~"Assesor standard met",
    ~"Board values", ~"Board standard met",
    
    "Accuracy", "Median ratio", "0.95-1.05",
    iaao_stats$median_ratio_SOP[which(iaao_stats$pass == "initial")], 
    ifelse(iaao_stats$median_ratio_standard_met[which(iaao_stats$pass == "initial")], "Yes", "No"), 
    iaao_stats$median_ratio_SOP[which(iaao_stats$pass == "mailed")], 
    ifelse(iaao_stats$median_ratio_standard_met[which(iaao_stats$pass == "mailed")], "Yes", "No"), 
    iaao_stats$median_ratio_SOP[which(iaao_stats$pass == "assessor")], 
    ifelse(iaao_stats$median_ratio_standard_met[which(iaao_stats$pass == "assessor")], "Yes", "No"), 
    iaao_stats$median_ratio_SOP[which(iaao_stats$pass == "board")], 
    ifelse(iaao_stats$median_ratio_standard_met[which(iaao_stats$pass == "board")], "Yes", "No"),
    
    "Variability", "COD", "5-15",
    iaao_stats$cod[which(iaao_stats$pass == "initial")], 
    ifelse(iaao_stats$cod_std_met[which(iaao_stats$pass == "initial")], "Yes", "No"), 
    iaao_stats$cod[which(iaao_stats$pass == "mailed")], 
    ifelse(iaao_stats$cod_std_met[which(iaao_stats$pass == "mailed")], "Yes", "No"), 
    iaao_stats$cod[which(iaao_stats$pass == "assessor")], 
    ifelse(iaao_stats$cod_std_met[which(iaao_stats$pass == "assessor")], "Yes", "No"), 
    iaao_stats$cod[which(iaao_stats$pass == "board")], 
    ifelse(iaao_stats$cod_std_met[which(iaao_stats$pass == "board")], "Yes", "No"),
    
    "Vertical Equity", "PRD", "0.98-1.03",
    iaao_stats$prd[which(iaao_stats$pass == "initial")], 
    ifelse(iaao_stats$prd_std_met[which(iaao_stats$pass == "initial")], "Yes", "No"), 
    iaao_stats$prd[which(iaao_stats$pass == "mailed")], 
    ifelse(iaao_stats$prd_std_met[which(iaao_stats$pass == "mailed")], "Yes", "No"), 
    iaao_stats$prd[which(iaao_stats$pass == "assessor")], 
    ifelse(iaao_stats$prd_std_met[which(iaao_stats$pass == "assessor")], "Yes", "No"), 
    iaao_stats$prd[which(iaao_stats$pass == "board")], 
    ifelse(iaao_stats$prd_std_met[which(iaao_stats$pass == "board")], "Yes", "No"),
    
    "Vertical Equity", "PRB", "-0.05-0.05",
    iaao_stats$prb[which(iaao_stats$pass == "initial")], 
    ifelse(iaao_stats$prb_std_met[which(iaao_stats$pass == "initial")], "Yes", "No"), 
    iaao_stats$prb[which(iaao_stats$pass == "mailed")], 
    ifelse(iaao_stats$prb_std_met[which(iaao_stats$pass == "mailed")], "Yes", "No"), 
    iaao_stats$prb[which(iaao_stats$pass == "assessor")], 
    ifelse(iaao_stats$prb_std_met[which(iaao_stats$pass == "assessor")], "Yes", "No"), 
    iaao_stats$prb[which(iaao_stats$pass == "board")], 
    ifelse(iaao_stats$prb_std_met[which(iaao_stats$pass == "board")], "Yes", "No")
    
  ) %>% 
    as.data.frame() %>%
    format(big.mark = ",", justify = "none", scientific = FALSE, digits = 2) %>%
    gt() %>%
    tab_header(
      title = "IAAO stats",
      subtitle = params$year)
}

# Print 3 plots showing IAAO stats
plot_IAAO <- function(plot_IAAO_data, params, available_pass) {
  
  if (available_pass != "initial") {
    
    plot_data <- plot_IAAO_data %>%
      filter(pass == available_pass)
    
  } else if (available_pass == "initial") {
    
    # Add board values to data frame to plot. The purpose is to create adjustment lines
    # We will replace every year that does not have initial values with Board values. 
    # The adjustment line will show that 
    data_board <- plot_IAAO_data %>% 
      filter(pass == "board", year < min(available_initial_years)) %>%
      dplyr::rename(board_cod = cod,
                    board_prd = prd,
                    board_prb = prb,
                    board_cod_CI_lower = cod_CI_lower,
                    board_cod_CI_upper = cod_CI_upper,
                    board_prd_CI_lower = prd_CI_lower,
                    board_prd_CI_upper = prd_CI_upper,
                    board_prb_CI_lower = prb_CI_lower,
                    board_prb_CI_upper = prb_CI_upper,
                    board_cod_std_met = cod_std_met,
                    board_prd_std_met = prd_std_met,
                    board_prb_std_met = prb_std_met) %>%
      select(year, starts_with("board"))
    # Join board variables with initial variables    
    data_initial <- plot_IAAO_data %>% 
      filter(pass == "initial") %>% 
      dplyr::rename(initial_cod = cod,
                    initial_prd = prd,
                    initial_prb = prb,
                    initial_cod_CI_lower = cod_CI_lower,
                    initial_cod_CI_upper = cod_CI_upper,
                    initial_prd_CI_lower = prd_CI_lower,
                    initial_prd_CI_upper = prd_CI_upper,
                    initial_prb_CI_lower = prb_CI_lower,
                    initial_prb_CI_upper = prb_CI_upper,
                    initial_cod_std_met = cod_std_met,
                    initial_prd_std_met = prd_std_met,
                    initial_prb_std_met = prb_std_met) %>%
      select(year, starts_with("initial")) %>%
      left_join(data_board, by = c("year")) %>%
      data.table()
    
    # Create adjustment lines
    data_initial[ , cod := board_cod]
    data_initial[is.na(cod), cod := initial_cod]
    
    data_initial[ , prb := board_prb]
    data_initial[is.na(prb), prb := initial_prb]
    
    data_initial[ , prd := board_prd]
    data_initial[is.na(prd), prd := initial_prd]
    
    data_initial[ , cod_CI_lower := board_cod_CI_lower]
    data_initial[is.na(cod_CI_lower), cod_CI_lower := initial_cod_CI_lower]
    
    data_initial[ , cod_CI_upper := board_cod_CI_upper]
    data_initial[is.na(cod_CI_upper), cod_CI_upper := initial_cod_CI_upper]
    
    data_initial[ , prb_CI_lower := board_prb_CI_lower]
    data_initial[is.na(prb_CI_lower), prb_CI_lower := initial_prb_CI_lower]
    
    data_initial[ , prb_CI_upper := board_prb_CI_upper]
    data_initial[is.na(prb_CI_upper), prb_CI_upper := initial_prb_CI_upper]
    
    data_initial[ , prd_CI_lower := board_prd_CI_lower]
    data_initial[is.na(prd_CI_lower), prd_CI_lower := initial_prd_CI_lower]
    
    data_initial[ , prd_CI_upper := board_prd_CI_upper]
    data_initial[is.na(prd_CI_upper), prd_CI_upper := initial_prd_CI_upper]
    
    data_initial[ , cod_std_met := board_cod_std_met]
    data_initial[is.na(cod_std_met), cod_std_met := initial_cod_std_met]
    
    data_initial[ , prb_std_met := board_prb_std_met]
    data_initial[is.na(prb_std_met), prb_std_met := initial_prb_std_met]
    
    data_initial[ , prd_std_met := board_prd_std_met]
    data_initial[is.na(prd_std_met), prd_std_met := initial_prd_std_met]
    # Filter data to plot
    plot_data <- data_initial %>% 
      select(year, cod:prd_std_met) %>% 
      filter(year != min(year))
    
  }
  # Replace empty cells with NA
  plot_data[is_empty(plot_data)] = NA
  # Create standard meet variables
  plot_data <- plot_data %>%
    mutate(cod_std_met = ifelse((cod_CI_lower >= 5 & cod_CI_lower <= 15) | (cod_CI_upper >= 5 & cod_CI_upper <= 15), "Yes", "No"),
           prd_std_met = ifelse((prd_CI_lower >= 0.98 & prd_CI_lower <= 1.03) | (prd_CI_upper >= 0.98 & prd_CI_upper <= 1.03), "Yes", "No"),
           prb_std_met = ifelse((prb_CI_lower >= -0.05 & prb_CI_lower <= 0.05) | (prb_CI_upper >= -0.05 & prb_CI_upper <= 0.05), "Yes", "No"))
  # Render first graph
  p1 <- ggplot(data = plot_data, aes(x = year, y = cod)) +
    geom_point(aes(color = cod_std_met, shape = cod_std_met), size = 3) +
    geom_line(color = "#D8A436") +
    geom_ribbon(aes(ymin = cod_CI_lower, ymax = cod_CI_upper), linetype = 2, alpha = 0.1) +
    scale_y_continuous(breaks = scales::breaks_extended(n = 10)) +
    scale_x_continuous(breaks = plot_data$year) + 
    
    scale_color_manual(
      values = c("red", "#006F45"),
      name = "Was the standard met?",
      labels = c("No", "Yes"),
      # Add breaks to standarize plotting
      breaks = c("No", "Yes")
    ) +
    
    scale_shape_manual(
      values = c(TRUE, FALSE),
      name = "Was the standard met?", 
      labels = c("No", "Yes"),
      breaks = c("No", "Yes")
    ) +
    
    labs(title = firstup(paste(available_pass, ' COD')), y = NULL) + 
    xlab(label = 'Year') +
    ylab(label = 'COD value') +
    geom_hline(yintercept = 5, linetype = 'dashed', color = 'black', size = 0.5) + 
    geom_hline(yintercept = 15, linetype = 'dashed', color = 'black', size = 0.5) + 
    geom_rect(xmin = min(-Inf), xmax = max(Inf), ymin = 5, ymax = 15, color = NA, fill = "#006F45", alpha = 0.01) +
    geom_rect(xmin = min(-Inf), xmax = max(Inf), ymin = 15, ymax = (Inf), color = NA, fill = "red", alpha = 0.01) +
    geom_rect(xmin = min(-Inf), xmax = max(Inf), ymin = (-Inf), ymax = 5, color = NA, fill = "red", alpha = 0.01) +
    theme_minimal() +
    coord_cartesian(ylim = c(min(plot_data$cod), max(plot_data$cod))) +
    theme(axis.text.x = element_text(angle = 60))
  # Render second graph
  p2 <- ggplot(data = plot_data, aes(x = year, y = prd)) +
    geom_point(aes(color = prd_std_met, shape = prd_std_met), size = 3) +
    geom_line(color = "#D8A436") +
    geom_ribbon(aes(ymin = prd_CI_lower, ymax = prd_CI_upper), linetype = 2, alpha = 0.1) +
    scale_y_continuous(breaks = scales::breaks_extended(n = 10)) +
    scale_x_continuous(breaks = plot_data$year) + 
    
    scale_color_manual(
      values = c("red", "#006F45"),
      name = "Was the standard met?",
      labels = c("No", "Yes"),
      breaks = c("No", "Yes")
    ) +
    
    scale_shape_manual(
      values = c(TRUE, FALSE),
      name = "Was the standard met?", 
      labels = c("No", "Yes"),
      breaks = c("No", "Yes")
    ) +
    
    labs(title = firstup(paste(available_pass, ' PRD')), y = NULL) + 
    xlab(label = 'Year') +
    ylab(label = 'PRD value') +
    geom_hline(yintercept = 0.98, linetype = 'dashed', color = 'black', size = 0.5) + 
    geom_hline(yintercept = 1.03, linetype = 'dashed', color = 'black', size = 0.5) + 
    geom_rect(xmin = min(-Inf), xmax = max(Inf), ymin = 0.98, ymax = 1.03, color = NA, fill = "#006F45", alpha = 0.01) +
    geom_rect(xmin = min(-Inf), xmax = max(Inf), ymin = 1.03, ymax = (Inf), color = NA, fill = "red", alpha = 0.01) +
    geom_rect(xmin = min(-Inf), xmax = max(Inf), ymin = (-Inf), ymax = 0.98, color = NA, fill = "red", alpha = 0.01) +
    theme_minimal() +
    coord_cartesian(ylim = c(min(plot_data$prd), max(plot_data$prd))) +
    theme(axis.text.x = element_text(angle = 60))
  # Render third graph
  p3 <- ggplot(data = plot_data, aes(x = year, y = prb)) +
    geom_point(aes(color = prb_std_met, shape = prb_std_met), size = 3) +
    geom_line(color = "#D8A436") +
    geom_ribbon(aes(ymin = prb_CI_lower, ymax = prb_CI_upper), linetype = 2, alpha = 0.1) +
    scale_y_continuous(breaks = scales::breaks_extended(n = 10)) +
    scale_x_continuous(breaks = plot_data$year) + 
    
    scale_color_manual(
      values = c("red", "#006F45"),
      name = "Was the standard met?",
      labels = c("No", "Yes"),
      breaks = c("No", "Yes")
    ) +
    
    scale_shape_manual(
      values = c(TRUE, FALSE),
      name = "Was the standard met?", 
      labels = c("No", "Yes"),
      breaks = c("No", "Yes")
    ) +
    
    labs(title = firstup(paste(available_pass, ' PRB')), y = NULL) + 
    xlab(label = 'Year') +
    ylab(label = 'PRB value') +
    geom_hline(yintercept = -0.05, linetype = 'dashed', color = 'black', size = 0.5) + 
    geom_hline(yintercept = 0.05, linetype = 'dashed', color = 'black', size = 0.5) + 
    geom_rect(xmin = min(-Inf), xmax = max(Inf), ymin = -0.05, ymax = 0.05, color = NA, fill = "#006F45", alpha = 0.01) +
    geom_rect(xmin = min(-Inf), xmax = max(Inf), ymin = 0.05, ymax = (Inf), color = NA, fill = "red", alpha = 0.01) +
    geom_rect(xmin = min(-Inf), xmax = max(Inf), ymin = (-Inf), ymax = -0.05, color = NA, fill = "red", alpha = 0.01) +
    theme_minimal() +
    coord_cartesian(ylim = c(min(plot_data$prb), max(plot_data$prb))) +
    theme(axis.text.x = element_text(angle = 60))
  # Return all graphs in a column
  return(grid.arrange(p1, p2, p3, 
                      nrow = 3, ncol = 1, 
                      top = firstup(paste0(available_pass, " IAAO values")))
  )
}

# Summary statistics table ----

# Return summary statistics table
sum_stats_tbl <- function(summary_stats_data, params, available_pass) {
  
  data <- summary_stats_data %>%
    filter(pass == available_pass)
  
  data <- tribble(
    #First row contains names of columns 
    ~"Blank", ~"year", ~"year - 1", ~"year - 3",
    
    # Second row
    "Median Sale Price", 
    data$median_sale_price[which(data$year == params$year)],
    data$median_sale_price[which(data$year == as.numeric(params$year) - 1)],
    data$median_sale_price[which(data$year == as.numeric(params$year) - 3)],
    
    # Third row
    "Median FCV",
    data %>% filter(year == params$year) %>% ungroup() %>% select(median_fmv),
    data %>% filter(year == as.numeric(params$year) - 1) %>% ungroup() %>% select(median_fmv),
    data %>% filter(year == as.numeric(params$year) - 3) %>% ungroup() %>% select(median_fmv),
    
    # Fourth row
    "N sales", 
    data$sales_n[which(data$year == params$year)],
    data$sales_n[which(data$year == as.numeric(params$year) - 1)],
    data$sales_n[which(data$year == as.numeric(params$year) - 3)],
    
    # Fifth row
    "N Pins", 
    data %>% filter(year == params$year) %>% ungroup() %>% select(pin_n),
    data %>% filter(year == as.numeric(params$year) - 1) %>% ungroup() %>% select(pin_n),
    data %>% filter(year == as.numeric(params$year) - 3) %>% ungroup() %>% select(pin_n),
    
    # Sixth row
    "Total FCV for PINS in modeling group", 
    data %>% filter(year == params$year) %>% ungroup() %>% select(sum_fmv), 
    data %>% filter(year == as.numeric(params$year) - 1) %>% ungroup() %>% select(sum_fmv), 
    data %>% filter(year == as.numeric(params$year) - 3) %>% ungroup() %>% select(sum_fmv) 
  )
  # Change column names
  names(data)[names(data) == "Blank"] <- "Statistic"
  names(data)[names(data) == "year"] <- params$year
  names(data)[names(data) == "year - 1"] <- as.numeric(params$year) - 1
  names(data)[names(data) == "year - 3"] <- as.numeric(params$year) - 3
  # Format numbers
  table <- data %>%
    as.data.frame() %>% 
    format(big.mark = ",", justify = "none", scientific = FALSE, digits = 0) %>%
    gt() %>%
    tab_header(
      title = "Summary statistics")
  
  return(table)
}

# Ratio visualization functions -----
# Graph median sales price
graph_sales_vs_median <- function(median_data, params, available_pass) {
  if (available_pass != "initial") {
    
    data <- median_data %>% 
      filter(pass == available_pass)
    
    return(
      ggplot(data = data) +
        geom_line(aes(x = year, y = fmv_25_pct) , linetype = 2, size = 1, color = "#006F45") +
        geom_point(aes(x = year, y = fmv_25_pct) , size = 2, color = "#006F45") +
        geom_line(aes(x = year, y = sale_price_25_pct), linetype = 1, size = 1, color = "#006F45") +
        geom_point(aes(x = year, y = sale_price_25_pct), size = 2, color = "#006F45") +
        
        geom_line(aes(x = year, y = median_fmv) , linetype = 2, size = 1, color = "#29428D") +
        geom_point(aes(x = year, y = median_fmv) , size = 2, color = "#29428D") +
        geom_line(aes(x = year, y = median_sale_price), linetype = 1, size = 1, color = "#29428D") +
        geom_point(aes(x = year, y = median_sale_price), size = 2, color = "#29428D") +
        
        geom_line(aes(x = year, y = fmv_75_pct) , linetype = 2, size = 1, color = "#FFAF00") +
        geom_point(aes(x = year, y = fmv_75_pct) , size = 2, color = "#FFAF00") +
        geom_line(aes(x = year, y = sale_price_75_pct), linetype = 1, size = 1, color = "#FFAF00") +
        geom_point(aes(x = year, y = sale_price_75_pct), size = 2, color = "#FFAF00") +
        labs(title = "Median fair market value (dashed lines) compared with median sale price (solid lines) at 3 percentiles", subtitle = "From top to bottom, lines represent 75th, 50th and 25th percentile", x = "Year", y = "Price") +
        scale_y_continuous(labels = comma) +
        scale_x_continuous(breaks = scales::extended_breaks(n = length(data$year))) +
        theme_minimal(base_size = 8) +
        theme(axis.text.x = element_text(angle = 60))
    )
    
  } else if (available_pass == "initial") {
    # Add board values to data frame to plot. The purpose is to create adjustment lines  
    data_board <- median_data %>% 
      filter(pass == "board", year < min(available_initial_years)) %>%
      dplyr::rename(board_25pct = fmv_25_pct,
                    board_50pct = median_fmv,
                    board_75pct = fmv_75_pct) %>%
      select(year, board_25pct, board_50pct, board_75pct) %>%
      arrange(year)
    # Join board variables with initial variables    
    data <- median_data %>% 
      filter(pass == "initial") %>% 
      left_join(data_board, by = c("year")) %>%
      arrange(year) %>%
      data.table()
    
    # Add adjustment lines to compare past assessments to initial values. 
    data[,adjuster_25 := board_25pct]
    data[is.na(adjuster_25), adjuster_25 := fmv_25_pct]
    data[,adjuster_50 := board_50pct]
    data[is.na(adjuster_50),adjuster_50 := median_fmv]
    data[,adjuster_75 := board_75pct]
    data[is.na(adjuster_75),adjuster_75 := fmv_75_pct]
    
    plot <- ggplot(data = data) +
      geom_line(aes(x = year, y = adjuster_25) , linetype = 2, size = 1, color = "#006F45") +
      geom_point(aes(x = year, y = adjuster_25) , size = 2, color = "#006F45") +
      geom_line(aes(x = year, y = sale_price_25_pct), linetype = 1, size = 1, color = "#006F45") +
      geom_point(aes(x = year, y = sale_price_25_pct), size = 2, color = "#006F45") +
      
      geom_line(aes(x = year, y = adjuster_50) , linetype = 2, size = 1, color = "#29428D") +
      geom_point(aes(x = year, y = adjuster_50) , size = 2, color = "#29428D") +
      geom_line(aes(x = year, y = median_sale_price), linetype = 1, size = 1, color = "#29428D") +
      geom_point(aes(x = year, y = median_sale_price), size = 2, color = "#29428D") +
      
      geom_line(aes(x = year, y = adjuster_75) , linetype = 2, size = 1, color = "#FFAF00") +
      geom_point(aes(x = year, y = adjuster_75) , size = 2, color = "#FFAF00") +
      geom_line(aes(x = year, y = sale_price_75_pct), linetype = 1, size = 1, color = "#FFAF00") +
      geom_point(aes(x = year, y = sale_price_75_pct), size = 2, color = "#FFAF00") +
      labs(title = "Median fair market value (dashed lines) compared with median sale price (solid lines) at 3 percentiles", subtitle = "From top to bottom, lines represent 75th, 50th and 25th percentile", x = "Year", y = "Price") +
      scale_y_continuous(labels = comma) +
      scale_x_continuous(breaks = scales::extended_breaks(n = length(data$year))) +
      theme_minimal(base_size = 8) +
      theme(axis.text.x = element_text(angle = 60))
    
    return(plot)
  }
}

# Graph percent of ratios within certain percentages
pct_ratios_within_pct_fun <- function(res_diag, params, available_pass) {
  
  # Count TRUE values of ratios within thresholds. 
  plot_data <- res_diag %>% 
    filter(year == params$year, pass %in% available_pass) %>%
    mutate(`0.9-1.1` = if_else(ratio_SOP >= 0.9 & ratio_SOP <= 1.1, TRUE, FALSE),
           `0.85-1.15` = ifelse((ratio_SOP >= 0.85 & ratio_SOP < 0.9) | 
                                  (ratio_SOP <= 1.15 & ratio_SOP > 1.1), TRUE, FALSE),
           `<0.85 & >1.15` = ifelse(ratio_SOP > 1.15 | 
                                      ratio_SOP < 0.85, TRUE, FALSE),
    ) %>% 
    group_by(pass) %>%
    summarise(`0.9-1.1` = sum(`0.9-1.1`, na.rm = TRUE),
              `0.85-1.15` = sum(`0.85-1.15`, na.rm = TRUE),
              `<0.85 & >1.15` = sum(`<0.85 & >1.15`, na.rm = TRUE)
    ) %>%
    pivot_longer(cols = `0.9-1.1`:`<0.85 & >1.15`, names_to = 'Percentage of absolute deviation', values_to = 'Count') %>%
    group_by(pass) %>% 
    # Create percentage variables
    mutate(`Percentage of ratios` = paste(round(Count / sum(Count, na.rm = TRUE) * 100, 2), "%"),
           `Percentage of absolute deviation` = factor(`Percentage of absolute deviation`, 
                                                       levels = c("0.9-1.1", "0.85-1.15", "<0.85 & >1.15")),
           `Pass` = factor(pass,
                           level = available_pass)) %>%
    select(-pass) 
  # Plot the count and percentage
  p1 <- ggplot(data = plot_data, aes(x = `Percentage of absolute deviation`, y = `Count`, 
                                     fill = Pass)) +
    geom_bar(stat = "identity", position = 'dodge') +
    scale_y_continuous(breaks = scales::breaks_extended(n = 5)) +
    scale_fill_discrete(
      type = c("358359", "#D8A436", "#81CA9C", "#00AFF0")
    ) +
    labs(title = firstup(paste('Count and percentage of ratios within some thresholds per pass'))
    ) +
    theme_minimal() +
    coord_cartesian(ylim = c(min(plot_data$Count), max(plot_data$Count))) +
    theme_minimal() +
    ggrepel::geom_label_repel(aes(label = `Percentage of ratios`),  
                              show.legend = FALSE)
  
  return(p1)
  
}

# Graph median ratioS 
median_ratios_fun <- function(median_data, params, available_pass) {
  if (available_pass == "board") {
    # If board get lead board ratio, lag board ratio, and board ratio SOP 
    plot_data <- median_data %>% 
      filter(pass == "board", year <= params$year) %>%
      rename(board_median_ratio_SOP = median_ratio_SOP) %>%
      pivot_longer(names_to = "Ratio types", values_to = "Values", 
                   cols = c(median_lead_ratio, median_lag_ratio, board_median_ratio_SOP))
    
  } else if (available_pass == "assessor") {
    # If assessor get lead assessor ratio, lag assessor ratio, and board ratio SOP.
    a <- median_data %>% 
      filter(pass == "assessor", year <= params$year) %>%
      select(year, median_lead_ratio, median_lag_ratio)
    
    plot_data <- median_data %>% 
      filter(pass == "board", year <= params$year) %>%
      mutate(board_median_ratio_SOP = median_ratio_SOP) %>% 
      select(year, board_median_ratio_SOP) %>% 
      left_join(., a, by = "year") %>% 
      pivot_longer(names_to = "Ratio types", values_to = "Values", 
                   cols = c(median_lead_ratio, median_lag_ratio, board_median_ratio_SOP))
    
  } else if (available_pass == "mailed") {
    # If mailed get lead mailed ratio, lag mailed ratio, and board ratio SOP.
    a <- median_data %>% 
      filter(pass == "mailed", year <= params$year) %>%
      select(year, median_lead_ratio, median_lag_ratio)
    
    plot_data <- median_data %>% 
      filter(pass == "board", year <= params$year) %>%
      mutate(board_median_ratio_SOP = median_ratio_SOP) %>% 
      select(year, board_median_ratio_SOP) %>% 
      left_join(., a, by = "year") %>% 
      pivot_longer(names_to = "Ratio types", values_to = "Values", 
                   cols = c(median_lead_ratio, median_lag_ratio, board_median_ratio_SOP))
    
  } else if (available_pass == "initial") {
    
    # Add board values to data frame to plot. The purpose is to create adjustment lines  
    data_board <- median_data %>% 
      filter(pass == "board", year < available_initial_years) %>%
      dplyr::rename(board_median_lead_ratio = median_lead_ratio,
                    board_median_ratio_SOP = median_ratio_SOP,
                    board_median_lag_ratio = median_lag_ratio) %>%
      select(year, board_median_lead_ratio, board_median_lag_ratio, board_median_ratio_SOP)
    # Join board variables with initial variables    
    data_initial <- median_data %>% 
      filter(pass == "initial") %>% 
      dplyr::rename(initial_median_lead_ratio = median_lead_ratio,
                    initial_median_lag_ratio = median_lag_ratio) %>%
      left_join(data_board, by = c("year")) %>%
      data.table()
    
    # Create adjustment lines
    data_initial <- data.table(data_initial)
    data_initial[,median_lead_ratio := board_median_lead_ratio]
    data_initial[is.na(median_lead_ratio), median_lead_ratio := initial_median_lead_ratio]
    data_initial[,median_lag_ratio := board_median_lag_ratio]
    data_initial[is.na(median_lag_ratio), median_lag_ratio := initial_median_lag_ratio]
    
    plot_data <- data_initial %>% 
      select(year, median_lead_ratio, median_lag_ratio, board_median_ratio_SOP) %>% 
      pivot_longer(names_to = "Ratio types", values_to = "Values", 
                   cols = c(median_lead_ratio, median_lag_ratio, board_median_ratio_SOP))
  }
  # Return plot
  return(
    ggplot(data = plot_data, aes(x = year, y = Values, color = `Ratio types`)) +
      geom_point() +
      geom_line() +
      scale_y_continuous(breaks = scales::breaks_extended(n = 10)) +
      scale_x_continuous(breaks = unique(plot_data$year)) + 
      
      scale_color_manual(
        values = c("median_lead_ratio" = "#D8A436", 
                   "median_lag_ratio" = "#2C4894", 
                   "board_median_ratio_SOP" = "#358359"),
        labels = c("Leading sale", "Lagging sale", "SOP transformed Board ratios")
      ) +
      
      labs(title = firstup(paste(available_pass, ' median ratios')), y = NULL,
           subtitle = 'According to SOPs, residential properties should have a median ranging from 0.95 to 1.05') + 
      xlab(label = 'Year') +
      ylab(label = 'Median ratio') +
      geom_hline(yintercept = 1.05, linetype = 'dashed', color = 'black', size = 0.5) + 
      geom_hline(yintercept = 0.95, linetype = 'dashed', color = 'black', size = 0.5) + 
      geom_rect(xmin = min(-Inf), xmax = max(Inf), ymin = 0.95, ymax = 1.05, color = NA, fill = "#FFAF00", alpha = 0.005) +
      theme_minimal() +
      coord_cartesian(ylim = c(min(plot_data$Values), max(plot_data$Values))) +
      theme(axis.text.x = element_text(angle = 60))
  )
}

# Graph ratios by decile
sales_ratio_by_decile <- function(ratio_decile_data, available_pass, quantile = 10, tax_year) {
  
  data <- ratio_decile_data %>% 
    filter(pass %in% available_pass, year == tax_year) %>%
    select("ratio_SOP", "fmv") %>% 
    drop_na() %>% 
    as.data.frame()
  
  assessed_value <- data[ , "fmv"] 
  
  ratios <- data[ , "ratio_SOP"]
  
  cut_ratios <- data.frame(assessed_value, ratios)
  
  if(nrow(cut_ratios) > 500) {
    cut_ratios$decile <- cut(cut_ratios$assessed_value, 
                             breaks = quantile(cut_ratios$assessed_value,
                                               probs = seq(0,1,1/quantile)),
                             labels = 1:quantile,
                             include.lowest = TRUE)
    
    # Calculate each decile's max fmv
    dec_max <- vector("character", quantile)
    
    for (i in 1:quantile) {
      df <- filter(cut_ratios, decile == i)
      dec_max[[i]] <- paste0("$",format(round(max(df$assessed_value),0),big.mark = ","))
    }
    
    # calculate each decile's median ratio
    dec_med_r <- vector("double",quantile)
    for (i in 1:quantile) {
      df <- filter(cut_ratios, decile == i)
      dec_med_r[[i]] <- median(df$ratios)
    }
    reg_line <- data.frame(ratios = dec_med_r, decile = as.factor(1:quantile))
    brx <- paste(c(1:quantile))
    
  } else {
    try(
      cut_ratios$decile <- cut(cut_ratios$assessed_value,
                               breaks = quantile(cut_ratios$assessed_value,
                                                 probs = seq(0,1,0.2)),
                               labels=1:5,
                               include.lowest = TRUE)
      , silent = TRUE
    )
    
    # calculate each decile's maximum AV
    try(
      dec_max <- vector("character", 5)
      , silent = TRUE
    )
    try(
      for (i in 1:5) {
        df <- filter(cut_ratios, decile == i)
        dec_max[[i]] <- paste0("$",format(round(max(df$assessed_value),0),big.mark=","))
      }
      , silent = TRUE
    )
    # calculate each decile's median ratio
    try(
      dec_med_r <- vector("double", 5)
      , silent = TRUE
    )
    try(
      for (i in 1:5) {
        df <- filter(cut_ratios, decile ==i)
        dec_med_r[[i]] <- median(df$ratios)
      }
      , silent = TRUE
    )
    try(
      reg_line <- data.frame(ratios = dec_med_r, decile = as.factor(1:5))
      , silent = TRUE
    )
    brx <- c('1','2','3','4','5')
    if (is.null(cut_ratios$decile)) {
      cut_ratios$decile <- 1
    }
    
    
    
  }
  
  # zoom boxplot automatically
  ylim1 = boxplot.stats(cut_ratios$ratios)$stats[c(1, 5)]
  quantile_name <- case_when(
    quantile == 3 ~ "Terciles",
    quantile == 4 ~ "Quartiles",
    quantile == 5 ~ "Quintiles",
    quantile == 6 ~ "Sextiles",
    quantile == 7 ~ "Septiles",
    quantile == 8 ~ "Octiles",
    quantile == 9 ~ "9 Quantiles",
    quantile == 10 ~ "Deciles"
  )
  
  # Return plot
  return(ggplot(cut_ratios, aes(y = ratios, x = decile)) +
           geom_boxplot(fill = "#2C4894", alpha = 0.75, color = "#954B36", outlier.shape = NA) +
           scale_x_discrete(breaks = brx,
                            labels = dec_max)+
           coord_cartesian(ylim = ylim1 * 1.05) +
           theme(panel.grid.minor.x = element_blank(),
                 panel.grid.major.x = element_blank(),
                 axis.ticks = element_blank(),
                 axis.text.x  = element_text(size = 10)) +
           labs(x = paste(quantile_name,"Maximum Assessed Value",sep=": "), y = NULL,
                title = "Sales Ratios & OLS Fit to Decile Median Ratio",
                subtitle = paste0("Tax Year ",tax_year)) +
           geom_smooth(data = reg_line, method= "lm", aes(group = 1), se = TRUE, color = "#D8A436") +
           theme_minimal(base_size = 8))
}

# Plot non SOP ratio distributions
ratio_distributions_non_SOP <- function(ratio_dist_data, params, available_pass) {
  
  # Filter data 
  data <- ratio_dist_data %>% 
    filter(pass == available_pass)
  # If current year is selected, show common and lag ratios
  if (params$year == lubridate::year(Sys.Date())) {
    
    p1 <- ggplot(data = data) +
      stat_ecdf(aes(x = ratio_non_SOP), size = 1.25, color = "#2C4894") +
      stat_ecdf(aes(x = lag_ratio), size = 1.25, color = "#D8A436") +
      xlim(0.7, 1.2) +
      labs(y = 'Cumulative percentage', x = "Ratios", title = "Cumulative distribution of common ratios and lagged ratios",
           subtitle = "Common ratios in blue. Lagged ratios in yellow.") +
      geom_vline(xintercept = 1, linetype = 'dashed') +
      geom_hline(yintercept = 0.5, linetype = 'dashed') +
      theme_minimal()
    
  } else {
    # If else show lead and lag ratios
    p1 <- ggplot(data = data) +
      stat_ecdf(aes(x = lead_ratio), size = 1.25, color = "#2C4894") +
      stat_ecdf(aes(x = lag_ratio), size = 1.25, color = "#D8A436") +
      xlim(0.7, 1.2) +
      labs(y = 'Cumulative percentage', x = "Ratios", title = "Cumulative distribution of lead ratios and lagged ratios",
           subtitle = "Lead ratios in blue. Lagged ratios in yellow.") +
      geom_vline(xintercept = 1, linetype = 'dashed') +
      geom_hline(yintercept = 0.5, linetype = 'dashed') +
      theme_minimal()
  }
  
  # Plot current and lagged assessment ratio distribution
  data_2 <- data %>% 
    filter(pass == available_pass, year == params$year)
  
  if (params$year == lubridate::year(Sys.Date())) {
    
    p2 <- ggplot(data = data_2) +
      geom_histogram(aes(x = ratio_non_SOP), breaks = c(seq(.5,1.5, by = 0.025)), fill = '#2C4894', alpha = 0.7) +
      geom_histogram(aes(x = lag_ratio), breaks = c(seq(.5,1.5, by = 0.025)), fill = '#D8A436', alpha = 0.6) +
      coord_cartesian(xlim = c(.5,1.5)) +
      labs(y = NULL, x = "Ratios", title = "Current and lagged distribution", 
           subtitle = "Current year in blue. Lagging year in yellow. Intersection as golden.") +
      scale_y_continuous(expand = c(0,0)) +
      theme_minimal()
    
  } else {
    # If else show lead and lag ratios
    p2 <- ggplot(data = data_2) +
      geom_histogram(aes(x = lead_ratio), breaks = c(seq(.5,1.5, by = 0.025)), fill = '#2C4894', alpha = 0.7) +
      geom_histogram(aes(x = lag_ratio), breaks = c(seq(.5,1.5, by = 0.025)), fill = '#D8A436', alpha = 0.6) +
      coord_cartesian(xlim = c(.5,1.5)) +
      labs(y = NULL, x = "Ratios", title = "Lead and lagged distribution",
           subtitle = "Leading year in blue. Lagging year in yellow. Intersection as golden.") +
      scale_y_continuous(expand = c(0,0)) +
      theme_minimal()
  }
  # Return plots in two rows
  return(grid.arrange(p1, p2, 
                      heights = c(2, 2),
                      widths = c(1, 1, 1, 1),
                      layout_matrix = rbind(c(1, 1, 1, NA),
                                            c(2, 2, 2, NA)),
                      top = firstup(paste0(available_pass, " assessment ratio distributions, ", params$year))))
}

# Plot SOP ratio distributions
ratio_distribution_SOP <- function(ratio_dist_data, params, available_pass) {
  
  # Filter data 
  data <- ratio_dist_data %>% 
    filter(pass == available_pass)
  
  # Plot distribution graph
  ggplot(data = data) +
    geom_histogram(aes(x = ratio_SOP), breaks = c(seq(.5,1.5, by = 0.025)), fill = '#2C4894', alpha = 0.7) + 
    geom_vline(aes(xintercept = mean(ratio_SOP, na.rm = TRUE)),
               color = "#29428D", linetype = "dashed", size = 1) +
    geom_vline(aes(xintercept = median(ratio_SOP, na.rm = TRUE)),
               color = "#006F45", linetype = "dashed", size = 1) +
    coord_cartesian(xlim = c(.5,1.5)) +
    labs(y = NULL, x = "Ratios", title = "SOP ratio distribution. Mean and median is shown.",  
         subtitle = "The mean is at the blue dashed line. The median is at the green dashed line") +
    scale_y_continuous(expand = c(0,0)) +
    theme_minimal()
  
}

# Sales chasing visualization ----
# Graph FMV change, lot size ratios, and building size ratios for sold/unsold properties
sales_chasing_vis <- function(sales_chasing_tests_data, params, available_pass) {
  # Filter the data
  data <- if (available_pass == "initial") { 
    sales_chasing_tests_data %>%
      filter(pass == "assessor", year == (as.numeric(params$year) - 1))
  } else {
    sales_chasing_tests_data %>%
      filter(pass == available_pass, year == params$year)
  }
  
  filter_data <- data[which(data$fmv_change_last_year != 0), ]
  # Plot change in fmv
  p1 <- ggplot(filter_data, aes(x = sell_status, y = fmv_change_last_year, fill = sell_status)) +
    geom_boxplot(varwidth = TRUE, outlier.shape = NA) +
    labs(y = "Change in FMV from last year", x = "Sell status") +
    scale_fill_manual(values = c(`sold` = "#FFDF99", 
                                 `unsold` = "#81CA9C")
    ) + 
    coord_cartesian(ylim = c(
      unname(quantile(filter_data$fmv_change_last_year, probs = seq(0, 1, 1/8), na.rm = TRUE))[2], 
      unname(quantile(filter_data$fmv_change_last_year, probs = seq(0, 1, 1/8), na.rm = TRUE))[8])) +
    theme_minimal() +
    theme(legend.position = "none")
  # Plot lot size over fmv
  p2 <- ggplot(data, aes(x = sell_status, y = lot_ratio, fill = sell_status)) +
    geom_boxplot(varwidth = TRUE, outlier.shape = NA)  +
    labs(y = "Lot size over FMV", x = "Sell status") +
    scale_fill_manual(values = c(`sold` = "#FFDF99", 
                                 `unsold` = "#81CA9C")
    ) + 
    coord_cartesian(ylim = c(
      unname(quantile(data$lot_ratio, probs = seq(0, 1, 1/8), na.rm = TRUE))[2], 
      unname(quantile(data$lot_ratio, probs = seq(0, 1, 1/8), na.rm = TRUE))[8])) +
    theme_minimal() +
    theme(legend.position = "none")
  # If Residential Condominium is selected ignore third grap
  # There is no building ratio data for Condominiums. 
  if (params$reporting_class != "Residential Condominium") {
    # Plot building size over fmv
    p3 <- ggplot(data, aes(x = sell_status, y = building_ratio, fill = sell_status)) +
      geom_boxplot(varwidth = TRUE, outlier.shape = NA) +
      labs(y = "Building size over FMV", x = "Sell status") +
      scale_fill_manual(values = c(`sold` = "#FFDF99", 
                                   `unsold` = "#81CA9C")
      ) + 
      coord_cartesian(ylim = c(
        unname(quantile(data$building_ratio, probs = seq(0, 1, 1/8), na.rm = TRUE))[2], 
        unname(quantile(data$building_ratio, probs = seq(0, 1, 1/8), na.rm = TRUE))[8])) +
      theme_minimal() +
      theme(legend.position = "none")
    
    return(
      grid.arrange(p1, p2, p3, nrow = 1, top = "Difference in three measures between sold and unsold properties")
    )
    
  } else {
    
    return(
      grid.arrange(p1, p2, nrow = 1, top = "Difference in three measures between sold and unsold properties")
           )
    
  }
}

# Sales chasing tests -----
# Detect sales chasing using the cumulative distribution function (CDF).
CDF_gap_test <- function(sales_chasing_tests_data, params, available_pass) {
  # Filter the data. 
  data <- sales_chasing_tests_data %>%
      filter(pass == available_pass, year == params$year)
  
  ratio <- data$ratio_SOP
  bounds = c(0.98, 1.02)
  cdf_gap = 0.03
  na.rm = TRUE
  
  # Sort the ratios and remove NAs
  sorted_ratio <- sort(ratio)
  
  # Calculate the CDF of the sorted ratios and extract percentile ranking
  cdf <- stats::ecdf(sorted_ratio)(sorted_ratio)
  
  # Calculate the difference between each value and the next value, the largest
  # difference will be the CDF gap
  diffs <- diff(cdf)
  
  # Check if the largest different is greater than the threshold and make sure
  # it's within the specified boundaries
  diff_loc <- sorted_ratio[which.max(diffs)]
  
  if ((max(diffs) > cdf_gap & (diff_loc > bounds[1] & diff_loc < bounds[2])) == FALSE) {
    
    out_cdf <- paste("The largest gap in the sample in the 0.98-1.02 bound is", round(max(diffs), 4))
    conclusion <-  "There is no evidence of sales chasing"
    
  } else {
    
    out_cdf <- paste("The largest gap in the sample in the 0.98-1.02 bound is", round(max(diffs), 4))
    conclusion <- "There is evidence of sales chasing"
    
  }
  
  table <- tribble(
    ~"Procedure", ~"Threshold", ~"Result", ~"Conclusion",
    # Largest CDF gap is the largest gap in the data of ratios around 1. 
    "Compute largest Empirical Cumulative Distribution (CDF) gap of ratios in the 0.98-1.02 bound", 
    "If the CDF gap is greater than 0.03 sales chasing is problable",
    out_cdf, conclusion) %>%
    gt() %>%  
    tab_header(
      title = "Largest gap in cumulative distribution of ratios",
      subtitle = "Sales chasing detection test")
  
  return(table)
  
}

# Detect sales chasing using the normal distribution function  
ideal_dist_test <- function(sales_chasing_tests_data, params, available_pass) {
  # Filter the data. 
  data <- sales_chasing_tests_data %>%
    filter(pass == available_pass, year == params$year)
  
  ratio <- data$ratio_SOP
  bounds = c(0.98, 1.02)
  cdf_gap = 0.03
  na.rm = TRUE
  
  # Return the percentage of x within the specified range
  pct_in_range <- function(x, min, max) mean(x >= min & x <= max, na.rm = na.rm)
  
  # Calculate the ideal normal distribution using observed values from input
  ideal_dist <- stats::rnorm(
    n = 10000,
    mean(ratio, na.rm = na.rm),
    stats::sd(ratio, na.rm = na.rm)
  )
  
  # Determine what percentage of the data would be within the specified bounds
  # in the ideal distribution
  pct_ideal <- pct_in_range(ideal_dist, bounds[1], bounds[2])
  
  # Determine what percentage of the data is actually within the bounds
  pct_actual <- pct_in_range(ratio, bounds[1], bounds[2])
  
  # Write conclusion
  if (pct_actual > pct_ideal) {
    
    conclusion <- "There is evidence of sales chasing"
    
  } else {
    
    conclusion <- "There is no evidence of sales chasing"
    
  }
  
  # Table the output
  table <- tribble(
    ~ "Procedure",
    ~ "Threshold",
    ~ "Result",
    ~ "Conclusion",
    # Largest CDF gap is the largest gap in the data of ratios around 1.
    "Compare ideal percentage of data to the actual percentage of data. Compare only 0.98-1.02 bound",
    "If the actual percentage of data is greater than the ideal percentage of data, sales chasing is problable",
    paste(
      "The percentage of actual ratios between 0.98 and 1.02 is ",
      round(pct_actual, 5),
      ". The percentage of the ideal ratio distribution is ",
      round(pct_ideal, 5),
      ". The difference is ",
      format(round(pct_actual - pct_ideal, 5), nsmall = 2)
    ),
    conclusion
  ) %>%
    gt() %>%
    tab_header(title = "Expected distribution of ratios",
               subtitle = "Sales chasing detection test")
  
  return(table)
  
}

# Run Mann Whitney test. Return table with test information. mwt1 stands for "Mann Whitman test 1"
Mann_Whitney_test_fun <- function(sales_chasing_tests_data, params, available_pass) {
  # Filter the data
  data <- if (available_pass == "initial") { 
    sales_chasing_tests_data %>%
      filter(pass == "assessor", year == (as.numeric(params$year) - 1))
  } else {
    sales_chasing_tests_data %>%
      filter(pass == available_pass, year == params$year)
  }
  
  # Transform infinities to NAs. We will have infinities when data is wrongly imputed. 
  data[sapply(data, is.infinite)] <- NA
  
  # Store Mann-Whitney test results   
  mwt1 <- wilcox.test(data$fmv_change_last_year[which(data$sell_status == "sold")], 
                      data$fmv_change_last_year[which(data$sell_status == "unsold")])
  
  mwt2 <- wilcox.test(data$lot_ratio[which(data$sell_status == "sold")], 
                      data$lot_ratio[which(data$sell_status == "unsold")])
  
  if (params$reporting_class == "Residential Condominium") {
    
    mwt3_out <- list("", "", "", 
                     "We do not store SqFt data for Residential Condominiums. This test cannot be run for this property class")
    
  } else {
    
    mwt3 <- wilcox.test(data$building_ratio[which(data$sell_status == "sold")], 
                        data$building_ratio[which(data$sell_status == "unsold")])
    
    if (mwt3$p.value < 0.01) {
      
      mwt3_out <- list(round(mwt3$p.value, 2), "No", 
                       paste0("The difference between the mean building price per square feet of unsold and sold propeties is $", 
                              round(mean(data$building_ratio[which(data$sell_status == "unsold")], na.rm = TRUE) 
                                    - mean(data$building_ratio[which(data$sell_status == "sold")], na.rm = TRUE), 2)),
                       "There is a significant difference in the mean building price per square feet between sold and unsold properties. 
                 Sales chasing is probable")
      
    } else { 
      
      mwt3_out <- list(round(mwt3$p.value, 2), "Yes", 
                       "Not statistically significant",
                       "There is a significant difference in the mean building price per square feet between sold and unsold properties. 
                 Sales chasing is probable")
      
    }
  }
  
  # Return difference in means. Tests significance to 1% level.
  if (mwt1$p.value < 0.01) {
    
    mwt1_out <- list(round(mwt1$p.value, 2), "No", 
                     paste0("The difference between change in FMV of unsold and sold propeties is $", 
                            round(mean(data$fmv_change_last_year[which(data$sell_status == "sold")], na.rm = TRUE) 
                                  - mean(data$fmv_change_last_year[which(data$sell_status == "unsold")], na.rm = TRUE), 2)),
                     "There is a significant difference in the mean change in FMV between sold and unsold properties. 
                 Sales chasing is probable")
    
  } else { 
    
    mwt1_out <- list(round(mwt1$p.value, 2), "Yes", "Not statistically significant",
                     "There is not a significant difference in the mean change in FMV between sold and unsold properties. 
                 Sales chasing is not probable")
    
  }
  
  if (mwt2$p.value < 0.01) {
    
    lot_data <- data %>%
      filter(lot_size != 0)
    
    mwt2_out <- list(round(mwt2$p.value, 2), "No", 
                     paste0("The difference between the mean lot price per square feet of unsold and sold propeties is $", 
                            round(mean(lot_data$lot_ratio[which(lot_data$sell_status == "sold")], na.rm = TRUE) 
                                  - mean(lot_data$lot_ratio[which(lot_data$sell_status == "unsold")], na.rm = TRUE), 2)),
                     "There is a significant difference in the mean lot price per square feet between sold and unsold properties. 
                 Sales chasing is probable")
    
  } else { 
    
    mwt2_out <- list(round(mwt2$p.value, 2), "Yes", "Not statistically significant",
                     "There is not a significant difference in the mean lot price per square feet between sold and unsold properties. 
                 Sales chasing is not probable")
  }
  
  # Table the output
  table <- tribble(
    ~"Procedure", ~"Is the p-value smaller than 0.01?", ~"Difference in means", ~"Conclusion",
    "Significant difference in average valuation change", paste(mwt1_out[[2]]), paste(mwt1_out[[3]]), paste(mwt1_out[[4]]),
    "Significant difference in ratio of lot size by FMV", paste(mwt2_out[[2]]), paste(mwt2_out[[3]]), paste(mwt2_out[[4]]),
    "Significant difference in ratio of building SqFt by FMV", paste(mwt3_out[[2]]), paste(mwt3_out[[3]]), paste(mwt3_out[[4]])
  ) %>% gt() %>%  
    tab_header(
      title = "Mann-Whitney test of significant difference",
      subtitle = "Sales chasing detection test")
  
  return(table)
}

# Appeals -----
# Graph total appeals and win percentages
total_appeals <- function(summary_appeals) {
  
  ggplot(data = summary_appeals, aes(x = year, y = total_wins)) +
    geom_bar(aes(y = total_appeals), stat = 'identity', fill = '#81CA9C', alpha = 0.9, color = 'black', size = 1) +
    geom_bar(aes(y = total_wins), stat = 'identity', width = 0.9, fill = '#00AFF0', color = 'black', size = 1) +
    labs(title = 'Assessment Appeals',
         subtitle = 'Total appeals filed in green. Successful appeals in blue.',
         x = 'Year and successful appeal rates') +
    scale_x_continuous(breaks = c(summary_appeals$year)) +
    # Add label with successful appeals percentage 
    ggrepel::geom_text_repel(aes(label = 
                                   paste0(round(total_wins/total_appeals, 2) * 100, "%"),
                                 y = 0), 
                             point.padding = NA,
                             fontface = 'bold', size = 4.5, vjust = 1.5, hjust = 0.5) +
    scale_y_continuous(name = "Number of Appeals",
                       labels = comma,
                       expand = expansion(mult = c(0.1, 0.1)),
                       breaks = scales::breaks_extended(n = 5),
                       sec.axis = sec_axis(trans = ~ . / max(summary_appeals$pin_n), 
                                           labels = percent_format(accuracy = 1),
                                           name = "Percentage of properties that appealed",
                                           breaks = scales::breaks_extended(n = 5))) +
    theme_minimal() +
    theme(axis.text.x = element_text(vjust = 0.5, angle = 60))
  
}

# Function to graph total fmv reduced from appeals.
reduced_fmv_appeals <- function(summary_appeals) {
  
  ggplot(data = summary_appeals, aes(x = year, y = sum_fmv_appealed)) +
    geom_bar(aes(y = sum_fmv_appealed), stat = 'identity', fill = '#81CA9C', alpha = 0.9, color = 'black', size = 1) +
    geom_bar(aes(y = total_reduction), stat = 'identity', width = 0.9, fill = '#954B34', color = 'black', size = 1) +
    labs(title = "Fair market value of properties that appealed and their respective reductions",
         x = 'Year') +
    scale_x_continuous(breaks = c(summary_appeals$year)) +
    # Add label showing all reductions over sum of fmv of properties that appealed
    ggrepel::geom_text_repel(data = summary_appeals,
                             aes(label = 
                                   paste0(round(total_reduction / sum_fmv_appealed * 100, 1), "%"),
                                 # Keep labels below bars
                                 y = 0), 
                             point.padding = NA, fontface = 'bold', size = 4.5, vjust = 1.5, hjust = 0.5) +
    scale_y_continuous(name = "Millions", 
                       labels = function(x) paste("$", format(x / 1000000)),
                       expand = expansion(mult = c(0.1, 0.1))) +
    theme_minimal() + 
    theme(axis.text.x = element_text(vjust = 0.5, angle = 60))
  
}

# Graph appeals rates, win rates, and reduction percentages. 
appeal_rates_vis <- function(data) {
  # Calculate quantiles
  quantiles <- quantile(data$fmv, probs = seq(.2, 1, by = .2), na.rm = TRUE)
  
  # Create quantiles. Use longer code with < > operators instead of between(). The between() function is slower.  
  quantile_1 <- data %>%
    filter(fmv <= unname(quantiles[1]))
  # Create summary data for the first quantile. This comment is shown once. 
  sum_quant_1 <- quantile_1 %>%
    filter(appeal_status != "Appealed none") %>%
    summarise(quantile_range = paste(paste0(round(min(quantile_1$fmv, na.rm = TRUE) / 1000000, 3)), paste0(round(max(quantile_1$fmv, na.rm = TRUE) / 1000000, 3), "M"), sep = "-"),
              total_appeals = n(),
              `Appeal rate` = total_appeals / nrow(quantile_1) * 100,
              total_wins = sum(complete.cases(both_appeal_result[which(both_appeal_result != "Lost both")])),
              `Successful appeal rate` = total_wins / total_appeals * 100,
              mean_reduction_pct = mean(both_reductions, na.rm = TRUE) / mean(fmv) * 100
    ) 
  
  quantile_2 <- data %>%
    filter(unname(quantiles[1]) < fmv & fmv <= unname(quantiles[2]))
  
  sum_quant_2 <- quantile_2 %>%
    filter(appeal_status != "Appealed none") %>%
    summarise(quantile_range = paste(paste0(round(min(quantile_2$fmv, na.rm = TRUE) / 1000000, 3)), paste0(round(max(quantile_2$fmv, na.rm = TRUE) / 1000000, 3), "M"), sep = "-"),
              total_appeals = n(),
              `Appeal rate` = total_appeals / nrow(quantile_1) * 100,
              total_wins = sum(complete.cases(both_appeal_result[which(both_appeal_result != "Lost both")])),
              `Successful appeal rate` = total_wins / total_appeals * 100,
              mean_reduction_pct = mean(both_reductions, na.rm = TRUE) / mean(fmv) * 100
    ) 
  
  quantile_3 <- data %>%
    filter(unname(quantiles[2]) < fmv & fmv <= unname(quantiles[3]))
  
  sum_quant_3 <- quantile_3 %>%
    filter(appeal_status != "Appealed none") %>%
    summarise(quantile_range = paste(paste0(round(min(quantile_3$fmv, na.rm = TRUE) / 1000000, 3)), paste0(round(max(quantile_3$fmv, na.rm = TRUE) / 1000000, 3), "M"), sep = "-"),
              total_appeals = n(),
              `Appeal rate` = total_appeals / nrow(quantile_1) * 100,
              total_wins = sum(complete.cases(both_appeal_result[which(both_appeal_result != "Lost both")])),
              `Successful appeal rate` = total_wins / total_appeals * 100,
              mean_reduction_pct = mean(both_reductions, na.rm = TRUE) / mean(fmv) * 100
    ) 
  
  quantile_4 <- data %>%
    filter(unname(quantiles[3]) < fmv & fmv <= unname(quantiles[4]))
  
  sum_quant_4 <- quantile_4 %>%
    filter(appeal_status != "Appealed none") %>%
    summarise(quantile_range = paste(paste0(round(min(quantile_4$fmv, na.rm = TRUE) / 1000000, 3)), paste0(round(max(quantile_4$fmv, na.rm = TRUE) / 1000000, 3), "M"), sep = "-"),
              total_appeals = n(),
              `Appeal rate` = total_appeals / nrow(quantile_1) * 100,
              total_wins = sum(complete.cases(both_appeal_result[which(both_appeal_result != "Lost both")])),
              `Successful appeal rate` = total_wins / total_appeals * 100,
              mean_reduction_pct = mean(both_reductions, na.rm = TRUE) / mean(fmv) * 100
    ) 
  
  quantile_5 <- data %>%
    filter(fmv > unname(quantiles[4]))
  
  sum_quant_5 <- quantile_5 %>%
    filter(appeal_status != "Appealed none") %>%
    summarise(quantile_range = paste(paste0(round(min(quantile_5$fmv, na.rm = TRUE) / 1000000, 3)), paste0(round(max(quantile_5$fmv, na.rm = TRUE) / 1000000, 3), "M"), sep = "-"), 
              total_appeals = n(),
              `Appeal rate` = total_appeals / nrow(quantile_1) * 100,
              total_wins = sum(complete.cases(both_appeal_result[which(both_appeal_result != "Lost both")])),
              `Successful appeal rate` = total_wins / total_appeals * 100,
              mean_reduction_pct = mean(both_reductions, na.rm = TRUE) / mean(fmv) * 100
    ) 
  # Bind all summaries of quantiles 
  sum_quant <- do.call("rbind", list(sum_quant_1, sum_quant_2, sum_quant_3, sum_quant_4, sum_quant_5)) %>%
    mutate(quantile_range = factor(quantile_range)
    ) %>% 
    pivot_longer(c(`Appeal rate`, `Successful appeal rate`), names_to = "Statistic", values_to = "Rates")
  # Plot appeal rates and successful appeal rates 
  p1 <- ggplot(data = sum_quant, 
               aes(x = Rates, y = quantile_range, fill = Statistic)) +
    geom_bar(position = "dodge", stat = "identity") +
    theme_minimal() + 
    scale_x_continuous(breaks = scales::breaks_extended(n = 10), labels = function(x) paste0(x, "%")) +
    labs(y = "Quantiles", x = "Rates", title = "Appeal rates and successful appeal rates per quantile") +
    theme(legend.position = "bottom") +
    scale_fill_manual(values = c("#29428D","#FFAF00"))
  # Plot reduction percentage per quantile
  p2 <- ggplot(data = sum_quant,
               aes(x = mean_reduction_pct, y = quantile_range)) +
    geom_bar(stat = "identity", fill = "#81CA9C") +
    theme_minimal() + 
    labs(y = "Quantile", x = "Reduction percentage", title = "Reduction percentage per quantile") +
    scale_x_continuous(breaks = scales::breaks_extended(n = 10), labels = function(x) paste0(x, "%")) 
  # Arrange in one column
  plots <- grid.arrange(p2, p1, ncol = 1)
  
  return(plots)
  
}

# Return plots of win percentages and ratios pre and post appeals per quantile. 
appeals_ratios_winners <- function(data, params) {
  
  # Calculate quantiles
  quantiles <- quantile(data$fmv, probs = seq(.2, 1, by = .2), na.rm = TRUE)
  
  # Create summary of quantiles. Use longer code with < > operators instead of between(). The between() function is slower.  
  median_quantile_1 <- data %>%
    filter(appeal_status != "Appealed none", fmv <= unname(quantiles[1])) %>% 
    summarise(quantile_range = paste(paste0(round(min(fmv, na.rm = TRUE) / 1000000, 3)), paste0(round(max(fmv, na.rm = TRUE) / 1000000, 3), "M"), sep = "-"),
              `Median pre-appeal ratio` = median(x = unlist(filter(., pass == "mailed")["ratio_SOP"]), na.rm = TRUE),
              `Median post-appeal ratio` = median(x = unlist(filter(., pass == "board")["ratio_SOP"]), na.rm = TRUE),
              `Percentage of successful appeals in at least one pass` = sum(complete.cases(both_appeal_result[which(both_appeal_result == "Won assessor only" | both_appeal_result == "Won board only" | both_appeal_result == "Won both")])) / n() * 100,
              `Percentage of unsuccessful appeals` = sum(complete.cases(both_appeal_result[which(both_appeal_result == "Lost both")])) / n() * 100,
              NAs = sum(is.na(both_appeal_result))
    )
  
  median_quantile_2 <- data %>%
    filter(appeal_status != "Appealed none", fmv > unname(quantiles[1]) & fmv <= unname(quantiles[2])) %>% 
    summarise(quantile_range = paste(paste0(round(min(fmv, na.rm = TRUE) / 1000000, 3)), paste0(round(max(fmv, na.rm = TRUE) / 1000000, 3), "M"), sep = "-"),
              `Median pre-appeal ratio` = median(x = unlist(filter(., pass == "mailed")["ratio_SOP"]), na.rm = TRUE),
              `Median post-appeal ratio` = median(x = unlist(filter(., pass == "board")["ratio_SOP"]), na.rm = TRUE),
              `Percentage of successful appeals in at least one pass` = sum(complete.cases(both_appeal_result[which(both_appeal_result == "Won assessor only" | both_appeal_result == "Won board only" | both_appeal_result == "Won both")])) / n() * 100,
              `Percentage of unsuccessful appeals` = sum(complete.cases(both_appeal_result[which(both_appeal_result == "Lost both")])) / n() * 100,
              NAs = sum(is.na(both_appeal_result))
    )
  
  median_quantile_3 <- data %>%
    filter(appeal_status != "Appealed none", unname(quantiles[2]) < fmv & fmv <= unname(quantiles[3])) %>% 
    summarise(quantile_range = paste(paste0(round(min(fmv, na.rm = TRUE) / 1000000, 3)), paste0(round(max(fmv, na.rm = TRUE) / 1000000, 3), "M"), sep = "-"),
              `Median pre-appeal ratio` = median(x = unlist(filter(., pass == "mailed")["ratio_SOP"]), na.rm = TRUE),
              `Median post-appeal ratio` = median(x = unlist(filter(., pass == "board")["ratio_SOP"]), na.rm = TRUE),
              `Percentage of successful appeals in at least one pass` = sum(complete.cases(both_appeal_result[which(both_appeal_result == "Won assessor only" | both_appeal_result == "Won board only" | both_appeal_result == "Won both")])) / n() * 100,
              `Percentage of unsuccessful appeals` = sum(complete.cases(both_appeal_result[which(both_appeal_result == "Lost both")])) / n() * 100,
              NAs = sum(is.na(both_appeal_result))
    )
  
  median_quantile_4 <- data %>%
    filter(appeal_status != "Appealed none", unname(quantiles[3]) < fmv & fmv <= unname(quantiles[4])) %>% 
    summarise(quantile_range = paste(paste0(round(min(fmv, na.rm = TRUE) / 1000000, 3)), paste0(round(max(fmv, na.rm = TRUE) / 1000000, 3), "M"), sep = "-"),
              `Median pre-appeal ratio` = median(x = unlist(filter(., pass == "mailed")["ratio_SOP"]), na.rm = TRUE),
              `Median post-appeal ratio` = median(x = unlist(filter(., pass == "board")["ratio_SOP"]), na.rm = TRUE),
              `Percentage of successful appeals in at least one pass` = sum(complete.cases(both_appeal_result[which(both_appeal_result == "Won assessor only" | both_appeal_result == "Won board only" | both_appeal_result == "Won both")])) / n() * 100,
              `Percentage of unsuccessful appeals` = sum(complete.cases(both_appeal_result[which(both_appeal_result == "Lost both")])) / n() * 100,
              NAs = sum(is.na(both_appeal_result))
    )
  
  median_quantile_5 <- data %>%
    filter(appeal_status != "Appealed none", fmv >= unname(quantiles[4])) %>% 
    summarise(quantile_range = paste(paste0(round(min(fmv, na.rm = TRUE) / 1000000, 3)), paste0(round(max(fmv, na.rm = TRUE) / 1000000, 3), "M"), sep = "-"),
              `Median pre-appeal ratio` = median(x = unlist(filter(., pass == "mailed")["ratio_SOP"]), na.rm = TRUE),
              `Median post-appeal ratio` = median(x = unlist(filter(., pass == "board")["ratio_SOP"]), na.rm = TRUE),
              `Percentage of successful appeals in at least one pass` = sum(complete.cases(both_appeal_result[which(both_appeal_result == "Won assessor only" | both_appeal_result == "Won board only" | both_appeal_result == "Won both")])) / n() * 100,
              `Percentage of unsuccessful appeals` = sum(complete.cases(both_appeal_result[which(both_appeal_result == "Lost both")])) / n() * 100,
              NAs = sum(is.na(both_appeal_result))
    )
  # Bind the data
  sum_quant <- do.call("rbind", list(median_quantile_1, median_quantile_2, median_quantile_3, median_quantile_4, median_quantile_5)) %>%
    mutate(quantile_range = factor(quantile_range)) %>% 
    pivot_longer(c(`Median pre-appeal ratio`, `Median post-appeal ratio`), names_to = "Statistic", values_to = "Median ratios") 
  # Plot ratios of appealed properties
  p1 <- sum_quant %>%
    mutate(quantile_range = fct_reorder(quantile_range, 1:10), .desc = TRUE) %>%
    ggplot(aes(x = quantile_range, y = `Median ratios`, fill = Statistic)) +
    geom_bar(position = position_dodge2(reverse = TRUE), stat = "identity") +
    theme_minimal() +
    scale_x_discrete(guide = guide_axis(n.dodge = 2)) +
    labs(x = "Quantiles", y = "Median ratio", title = "Sales ratios of properties that appealed in the last 3 years") +
    scale_fill_manual(values = c("#006F45","#FFAF00")) +
    guides(fill = guide_legend(nrow = 2, byrow = TRUE))
  
  return(p1)  
  
}

# Plot year over year fmv change
plot_yoy_fmv_change <- function(yoy_fmv_change_data, params, available_pass) {
  # Create two data frames. One for properties that appealed and one for properties that didn't
  # If pass is initial, use assessor data from last year 
  if (available_pass == "initial") {
    
    no_appeal <- yoy_fmv_change_data %>%
      filter(appeal_status == "Appealed none", pass == "assessor", year == params$year - 1)
    
    appeal <- yoy_fmv_change_data %>%
      filter(appeal_status != "Appealed none", pass == "assessor", year == params$year - 1)
  # If else get current's year data
  } else if (available_pass != "initial") {
    
    no_appeal <- yoy_fmv_change_data %>%
      filter(appeal_status == "Appealed none", pass == available_pass,  year == params$year)
    
    appeal <- yoy_fmv_change_data %>%
      filter(appeal_status != "Appealed none", pass == available_pass,  year == params$year)
  }
  # Calculate the year over year percentage change for properties that appealed and properties that didn't 
  change_no_appeal <- no_appeal %>%
    mutate(yoy_pct_change_no_appeal = (fmv - lagged_fmv)/lagged_fmv * 100) %>%
    filter(yoy_pct_change_no_appeal != 0) %>%
    select(year, yoy_pct_change_no_appeal)
  
  change_appeal <- appeal %>%
    mutate(yoy_pct_change_appeal = (fmv - lagged_fmv)/lagged_fmv * 100) %>%
    filter(yoy_pct_change_appeal != 0) %>%
    select(year, yoy_pct_change_appeal)
  # Merge data frames
  plot_data <- change_appeal %>%
    bind_rows(change_no_appeal) %>%
    rename(`Properties that did not appeal` = yoy_pct_change_no_appeal,
           `Properties that appealed` = yoy_pct_change_appeal) %>%
    pivot_longer(cols = `Properties that did not appeal`:`Properties that appealed`, 
                 values_to = "Year over year FMV change", names_to = "Status")
  # Plot data
  ggplot(data = plot_data, aes(x = Status, y = `Year over year FMV change`, fill = Status)) +
    geom_boxplot() + 
    labs(title = firstup(paste(available_pass, ' year over year percentage change in FMV')), y = NULL) + 
    xlab(label = element_blank()) +
    ylab(label = 'Median FMV percentage change') +
    theme_minimal() +
    scale_fill_manual(values = c(`Properties that did not appeal` = "#00AFF0", 
                                 `Properties that appealed` = "#81CA9C")
    ) + 
    # Set y limits to be the second and eight quantile of data 
    coord_cartesian(ylim = c(
      unname(quantile(plot_data$`Year over year FMV change`, probs = seq(0, 1, 1/8), na.rm = TRUE))[2], 
      unname(quantile(plot_data$`Year over year FMV change`, probs = seq(0, 1, 1/8), na.rm = TRUE))[8])
    ) +
    theme(axis.text.x = element_blank(), legend.position = "bottom")
  
}

# Leaflet map ----
# Render leaflet map. Contains mappings of several stats per neighborhood.  
leaflet_fun <- function(sum_diag, params, available_pass) {
  # Download cook county shapes using ccao package. 
  map <- ccao::nbhd_shp
  
  nbhd_no_appeals <- sum_diag %>% 
    filter(Geography == "Neighborhood", year == params$year, pass == 'mailed') %>%
    mutate(nbhd_std = ifelse(nchar(Sub_geography) < 3, paste0("0", Sub_geography), Sub_geography)) %>% 
    select(-total_reduction, -total_wins)
  # Extract appeals data for year that has appeals data
  nbhd_appeals <- sum_diag %>% 
    filter(Geography == "Neighborhood", year == available_appeals_year, pass == 'mailed') %>%
    mutate(nbhd_std = ifelse(nchar(Sub_geography) < 3, paste0("0", Sub_geography), Sub_geography),
           # Divide reduction by 1000000 to represent it as millions
           total_reduction = total_reduction / 1000000
    ) %>%
    select(total_reduction, total_wins)
  
  nbhd <- nbhd_no_appeals %>%
    left_join(nbhd_appeals, by = c("Geography", "Sub_geography", "reporting_class", "pass"))
  # Merge data
  all_nbhd <- left_join(map, nbhd, by = c("nbhd" = "nbhd_std"))
  
  # Limit map to data in a township, if a township was selected
  if (params$geography == "Township"){
    
    all_nbhd <- all_nbhd %>%
      
      dplyr::filter(township_name == params$sub_geography)
  # Else limit to triad  
  } else if (params$geography == "Triad"){
    
    all_nbhd <- all_nbhd %>%
      
      dplyr::filter(triad_name == params$sub_geography)
    
  }
  
  # Create leaflet objects. Each of these objects is used to add a new visualization layer on the map. 
  # Create COD leaflet requiered objects
  bins_cod <- c(0, 15, 20, 25, 30, 35, 40, Inf)
  pal_cod <- colorBin(palette = c("#7CFC00", "#ffffb2", "#fecc5c", "#fd8d3c", "#f03b20", "#bd0026", "#ff0000"), 
                      domain = all_nbhd$cod, bins = bins_cod)
  label_cod <- sprintf(
    "<strong> %s </strong> <br/> Neighborhood number: %s <br/> Median fmv: %g <br/> Median sale price: %g <br/> COD: %g",
    all_nbhd$township_name, all_nbhd$nbhd, all_nbhd$median_fmv, all_nbhd$median_sale_price, round(all_nbhd$cod, 3)
  ) %>% 
    lapply(htmltools::HTML)
  
  # Create PRB leaflet requiered objects
  bins_prb <- c(-Inf, -1, -0.1, -0.05, 0.05, 0.1, 1, Inf)
  pal_prb <- colorBin(palette = c("#ff0000", "#f03b20", "#fecc5c", "#7CFC00", "#7CFC00", "#fecc5c", "#f03b20", "#ff0000"), 
                      domain = all_nbhd$prb, bins = bins_prb)
  label_prb <- sprintf(
    "<strong> %s </strong> <br/> Neighborhood number: %s <br/> Median fmv: %g <br/> Median sale price: %g <br/> PRB: %g",
    all_nbhd$township_name, all_nbhd$nbhd, all_nbhd$median_fmv, all_nbhd$median_sale_price, round(all_nbhd$prb, 3)
  ) %>% 
    lapply(htmltools::HTML)
  
  # Create PRD leaflet requiered objects
  bins_prd <- c(-Inf, 0, 0.9, 0.98, 1.03, 1.1, 2, Inf)
  pal_prd <- colorBin(palette = c("#ff0000", "#f03b20", "#fecc5c", "#7CFC00", "#7CFC00", "#fecc5c", "#f03b20", "#ff0000"), 
                      domain = all_nbhd$prd, bins = bins_prd)
  label_prd <- sprintf(
    "<strong> %s </strong> <br/> Neighborhood number: %s <br/> Median fmv: %g <br/> Median sale price: %g <br/> PRD: %g",
    all_nbhd$township_name, all_nbhd$nbhd, all_nbhd$median_fmv, all_nbhd$median_sale_price, round(all_nbhd$prd, 3)
  ) %>% 
    lapply(htmltools::HTML)
  
  # Create median ratio leaflet requiered objects
  bins_median_ratio <- c(-Inf, 0.3, 0.9, 0.95, 1.05, 1.1, 1.8, Inf)
  pal_median_ratio <- colorBin(palette = c("#ff0000", "#f03b20", "#fecc5c", "#7CFC00", "#7CFC00", "#fecc5c", "#f03b20", "#ff0000"), 
                               domain = all_nbhd$median_ratio_SOP, bins = bins_median_ratio)
  label_median_ratio <- sprintf(
    "<strong> %s </strong> <br/> Neighborhood number: %s <br/> Median fmv: %g <br/> Median sale price: %g <br/> Median ratio: %g",
    all_nbhd$township_name, all_nbhd$nbhd, all_nbhd$median_fmv, all_nbhd$median_sale_price, round(all_nbhd$median_ratio_SOP, 3)
  ) %>% 
    lapply(htmltools::HTML)
  
  # Create appeal total wins leaflet requiered objects
  bins_total_wins <- c(0, 100, 250, 500, 1000, 2000, 3000, 4000, Inf)
  pal_total_wins <- colorBin(palette = "Blues", 
                             domain = all_nbhd$total_wins, bins = bins_total_wins)
  label_total_wins <- sprintf(
    "<strong> %s </strong> <br/> Neighborhood number: %s <br/> Median fmv: %g <br/> Median sale price: %g <br/> Amount of properties that got a reduction: %g",
    all_nbhd$township_name, all_nbhd$nbhd, all_nbhd$median_fmv, all_nbhd$median_sale_price, all_nbhd$total_wins
  ) %>% 
    lapply(htmltools::HTML)
  
  # Create appeal total reduction leaflet requiered objects
  bins_total_reduction <- c(0, 0.01, 0.1, 1, 10, 50, 100, 150, 300, Inf)
  pal_total_reduction <- colorBin(palette = "Reds", 
                                  domain = all_nbhd$total_reduction, bins = bins_total_reduction)
  label_total_reduction <- sprintf(
    "<strong> %s </strong> <br/> Neighborhood number: %s <br/> Median fmv: %g <br/> Median sale price: %g <br/> Appeal reduction in millions of dollars: $%g",
    all_nbhd$township_name, all_nbhd$nbhd, all_nbhd$median_fmv, all_nbhd$median_sale_price, round(all_nbhd$total_reduction, 3)
  ) %>% 
    lapply(htmltools::HTML)
  
  # Create year over year change in fmv leaflet requiered objects
  bins_pct_change_fmv <- c(-Inf, -50, -25, -10, -5, 0, 5, 10, 25, 50, Inf)
  pal_pct_change_fmv <- colorBin(palette = "Greens", 
                                 domain = all_nbhd$pct_change_fmv, bins = bins_pct_change_fmv)
  label_pct_change_fmv <- sprintf(
    "<strong> %s </strong> <br/> Neighborhood number: %s <br/> Median fmv: %g <br/> Median sale price: %g <br/> Percent change in FMV: %g",
    all_nbhd$township_name, all_nbhd$nbhd, all_nbhd$median_fmv, all_nbhd$median_sale_price, round(all_nbhd$pct_change_fmv, 3)
  ) %>% 
    lapply(htmltools::HTML)
  
  # Create leaflet map
  leaflet_map <- leaflet(all_nbhd) %>%
    addTiles() %>% 
    setView(-87.631442, 41.883960, zoom = 10) %>%
    # Add polygons for every stat using the objects created before
    addPolygons(
      fillColor = ~pal_cod(cod),
      weight = 2,
      opacity = 1,
      color = "white",
      dashArray = "3",
      fillOpacity = 0.7,
      highlight = highlightOptions(
        weight = 5,
        color = "#666",
        dashArray = "",
        fillOpacity = 0.7,
        bringToFront = TRUE),
      label = label_cod,
      group = "COD") %>% 
    
    addPolygons(
      fillColor = ~pal_prb(prb),
      weight = 2,
      opacity = 1,
      color = "white",
      dashArray = "3",
      fillOpacity = 0.7,
      highlight = highlightOptions(
        weight = 5,
        color = "#666",
        dashArray = "",
        fillOpacity = 0.7,
        bringToFront = TRUE),
      label = label_prb,
      group = "PRB") %>%
    
    addPolygons(
      fillColor = ~pal_prd(prd),
      weight = 2,
      opacity = 1,
      color = "white",
      dashArray = "3",
      fillOpacity = 0.7,
      highlight = highlightOptions(
        weight = 5,
        color = "#666",
        dashArray = "",
        fillOpacity = 0.7,
        bringToFront = TRUE),
      label = label_prd,
      group = "PRD") %>% 
    
    addPolygons(
      fillColor = ~pal_median_ratio(median_ratio_SOP),
      weight = 2,
      opacity = 1,
      color = "white",
      dashArray = "3",
      fillOpacity = 0.7,
      highlight = highlightOptions(
        weight = 5,
        color = "#666",
        dashArray = "",
        fillOpacity = 0.7,
        bringToFront = TRUE),
      label = label_median_ratio,
      group = "Median-ratio") %>% 
    
    addPolygons(
      fillColor = ~pal_total_wins(total_wins),
      weight = 2,
      opacity = 1,
      color = "white",
      dashArray = "3",
      fillOpacity = 0.7,
      highlight = highlightOptions(
        weight = 5,
        color = "#666",
        dashArray = "",
        fillOpacity = 0.7,
        bringToFront = TRUE),
      label = label_total_wins,
      group = "Properties-&-reduction") %>%
    
    addPolygons(
      fillColor = ~pal_total_reduction(total_reduction),
      weight = 2,
      opacity = 1,
      color = "white",
      dashArray = "3",
      fillOpacity = 0.7,
      highlight = highlightOptions(
        weight = 5,
        color = "#666",
        dashArray = "",
        fillOpacity = 0.7,
        bringToFront = TRUE),
      label = label_total_reduction,
      group = "Total-appeal-reduction") %>%
    
    addPolygons(
      fillColor = ~pal_pct_change_fmv(pct_change_fmv),
      weight = 2,
      opacity = 1,
      color = "white",
      dashArray = "3",
      fillOpacity = 0.7,
      highlight = highlightOptions(
        weight = 5,
        color = "#666",
        dashArray = "",
        fillOpacity = 0.7,
        bringToFront = TRUE),
      label = label_pct_change_fmv,
      group = "Percent-change-FMV") %>%
    # Add legends for every stat
    addLegend(pal = pal_cod, 
              values = ~density, 
              opacity = 0.7, 
              title = "Neighborhood COD",
              position = "bottomright",
              group = "COD",
              className = "info legend COD") %>%
    
    addLegend(pal = pal_prb, 
              values = ~density, 
              opacity = 0.7, 
              title = "Neighborhood PRB",
              position = "bottomright",
              group = "PRB",
              className = "info legend PRB") %>%
    
    addLegend(pal = pal_prd, 
              values = ~density, 
              opacity = 0.7, 
              title = "Neighborhood PRD",
              position = "bottomright",
              group = "PRD",
              className = "info legend PRD") %>%
    
    addLegend(pal = pal_median_ratio, 
              values = ~density, 
              opacity = 0.7, 
              title = "Neighborhood median ratio",
              position = "bottomright",
              group = "Median-ratio",
              className = "info legend Median-ratio") %>%
    
    addLegend(pal = pal_total_wins, 
              values = ~density, 
              opacity = 0.7, 
              title = "Amount of properties that got a reduction in the neighborhood",
              position = "bottomright",
              group = "Properties-&-reduction",
              className = "info legend Properties-&-reduction") %>%
    
    addLegend(pal = pal_total_reduction, 
              values = ~density, 
              opacity = 0.7, 
              title = "Total amount of appeal reduction in the neighborhood in millions of dollars",
              position = "bottomright",
              group = "Total-appeal-reduction",
              className = "info legend Total-appeal-reduction") %>%
    
    addLegend(pal = pal_pct_change_fmv, 
              values = ~density, 
              opacity = 0.7, 
              title = "Percent change FMV compared to last year",
              position = "bottomright",
              group = "Percent-change-FMV",
              className = "info legend Percent-change-FMV") %>%
    # Add base groups that will be shown in the map. 
    addLayersControl(
      baseGroups = c("COD", "PRB", "PRD", "Median-ratio", "Properties-&-reduction", "Total-appeal-reduction", "Percent-change-FMV"),
      options = layersControlOptions(collapsed = FALSE)
    ) %>% 
    # This widget written in html will allow to change between legend of when switching betwwen base groups.
    # Follow this link for more information https://stackoverflow.com/questions/52393310/is-it-possible-to-switch-between-multiple-legends-when-switching-between-base-gr
    htmlwidgets::onRender("
      function(el, x) {
         var updateLegend = function () {
            var selectedGroup = document.querySelectorAll('input:checked')[0].nextSibling.innerText.substr(1);

            document.querySelectorAll('.legend').forEach(a => a.hidden=true);
            document.querySelectorAll('.legend').forEach(l => {
               if (l.classList.contains(selectedGroup)) l.hidden=false;
            });
         };
         updateLegend();
         this.on('baselayerchange', el => updateLegend());
      }"
    )
  
  return(leaflet_map)
  
}
